<template>
  <q-layout view="hHh lpR fFf">
    <q-header
      elevated
      class="bg-primary text-white"
    >
      <q-tabs
        inline-label
        class="q-pr-md q-pl-sm"
      >
        <q-btn
          dense
          flat
          icon="menu"
          label="Jízdní řády"
          @click="timetableDrawer = !timetableDrawer"
        />

        <q-space />
        <q-separator
          dark
          vertical
        />

        <q-toolbar-title class="gt-md">
          <router-link
            :to="{name: 'home'}"
            class="homelink"
          >
            <q-avatar>
              <img
                alt="icon"
                src="@/assets/icon-train-blue.svg"
              >
            </q-avatar>
            Kolejiště FEL ZČU
          </router-link>
        </q-toolbar-title>

        <q-route-tab
          icon="train"
          :to="{name: 'about'}"
        >
          O kolejišti
        </q-route-tab>

        <q-route-tab
          icon="pending_actions"
          :to="{name: 'timetable'}"
        >
          Jízdní řády
        </q-route-tab>

        <q-btn-dropdown
          v-if="user.canAdminUser || user.canCrudTimetable || user.canSeeError || user.canCrudHwAdmin"
          label="Administrace"
          icon="settings_applications"
          auto-close
          stretch
          flat
        >
          <q-route-tab
            v-if="user.canAdminUser"
            icon="people"
            :to="{name: 'adminUser'}"
          >
            Uživatelé
          </q-route-tab>

          <q-route-tab
            v-if="user.canCrudTimetable"
            icon="pending_actions"
            :to="{name: 'adminTimetable'}"
          >
            Jízdní řády
          </q-route-tab>

          <q-route-tab
            v-if="user.canSeeError"
            icon="report_problem"
            :to="{name: 'adminError'}"
          >
            Chyby
          </q-route-tab>

          <q-route-tab
            v-if="user.canCrudHwAdmin"
            icon="cable"
            :to="{name: 'adminHardware'}"
          >
            Hardware
          </q-route-tab>
        </q-btn-dropdown>

        <q-btn-dropdown
          v-if="user.logged"
          :label="user.data.name"
          icon="person"
          auto-close
          stretch
          flat
        >
          <q-route-tab
            icon="settings"
            :to="{name: 'user'}"
          >
            Nastavení
          </q-route-tab>
          <q-route-tab
            icon="logout"
            :to="{name: 'signOut'}"
          >
            Odhlásit se
          </q-route-tab>
        </q-btn-dropdown>

        <q-route-tab
          v-if="!user.logged"
          icon="login"
          :to="{name: 'signIn'}"
        >
          Přihlásit se
        </q-route-tab>
        <q-route-tab
          v-if="!user.logged"
          icon="account_circle"
          :to="{name: 'register'}"
        >
          Registrovat se
        </q-route-tab>
        <q-separator
          dark
          vertical
        />

        <q-space />

        <q-btn
          dense
          flat
          icon="menu"
          label="Vlaky"
          @click="trainDrawer = !trainDrawer"
        />
      </q-tabs>
    </q-header>

    <timetable-drawer
      :drawer="timetableDrawer"
    />

    <train-drawer
      :drawer="trainDrawer"
      :detail="!user.canCrudHwAdmin"
    />

    <q-page-container>
      <router-view />
    </q-page-container>

    <q-footer class="bg-grey-9 text-white">
      <q-toolbar>
        <q-toolbar-title>
          <router-link
            :to="{name: 'home'}"
            class="homelink"
          >
            Kolejiště FEL ZČU
          </router-link>
        </q-toolbar-title>

        <router-link
          :to="{name: 'attribution'}"
          class="attribution"
        >
          Zdroje
        </router-link>

        <a
          class="footer-icon"
          target="_blank"
          href="https://gitlab.com/krystof.trko/web_trains"
        ><img
          alt="FEL"
          src="@/assets/fel.svg"
        ></a>

        <a
          class="footer-icon"
          target="_blank"
          href="https://gitlab.com/krystof.trko/web_trains"
        ><img
          alt="gitlab"
          src="@/assets/gitlab.svg"
        ></a>
      </q-toolbar>
    </q-footer>
  </q-layout>
</template>

<script lang="ts">
import { ref } from '@vue/reactivity'
import { watch } from '@vue/runtime-core'
import { useRouter } from 'vue-router'

import TimetableDrawer from '@/components/TimetableDrawer.vue'
import TrainDrawer from '@/components/TrainDrawer.vue'
import { setRouter } from '@/exception/ExceptionHandler'
import { Route } from '@/router/routes'
import useUserStore from '@/store/userStore'

export default {
  name: 'App',
  components: { TrainDrawer, TimetableDrawer },
  setup (): any {
    const router = useRouter()
    setRouter(router) // redirecting for axios requests

    const user = useUserStore()
    user.init()

    // loading animation
    const anim = document.getElementById('init-anim')

    if (anim) {
      anim.remove()
    }

    // Left and right drawer
    const trainDrawer = ref(false)
    const timetableDrawer = ref(false)

    watch(router.currentRoute, (to) => {
      if (to.name === Route.home) {
        trainDrawer.value = true
      } else {
        trainDrawer.value = false
        timetableDrawer.value = false
      }
    })

    return {
      user,
      trainDrawer,
      timetableDrawer
    }
  }
}
</script>
